@echo off
chcp 1252

REM ==================================================================
REM Pfade setzen (von qgis-ltr-start.bat übernommen)
REM ==================================================================

call "%~dp0\o4w_env.bat"
@echo off
path %OSGEO4W_ROOT%\apps\qgis-ltr\bin;%PATH%
set QGIS_PREFIX_PATH=%OSGEO4W_ROOT:\=/%/apps/qgis-ltr
set GDAL_FILENAME_IS_UTF8=YES

REM VSI-Cache als Puffer einstellen, siehe # 6448
set VSI_CACHE=TRUE
set VSI_CACHE_SIZE=1000000
set QT_PLUGIN_PATH=%OSGEO4W_ROOT%\apps\qgis-ltr\qtplugins;%OSGEO4W_ROOT%\apps\qt5\plugins


REM ==================================================================
REM BETA2007 ergänzen
REM ==================================================================

REM Patch QGIS-EPSG-DB für die deutsche BeTA-2007-Transformation (GK2/3/4/5->UTM32/33)
"%OSGEO4W_ROOT%"\bin\sqlite3.exe "%OSGEO4W_ROOT%"\apps\qgis-ltr\resources\srs.db < "%OSGEO4W_ROOT%"\apps\qgis-ltr\resources\BETA2007.sql

REM ==================================================================
REM Variablen füllen
REM ==================================================================

REM Endgültiger Pfad zum QGIS Benutzer-Verzeichnis
set "QGIS_UDIR=%USERPROFILE%\AppData\Roaming\QGIS\qgis-ltr"

REM Bezeichnung für das Desktop Icon
set "QGIS_TEXT=QGIS LTR"

REM Überprüfen, ob das Benutzerverzeichnis bereits existiert
if exist %QGIS_UDIR% goto ende

echo Installiere das Verzeichnis für die Benutzereinstellungen ...

REM Skript aufrufen, das während der Vorbereitungsphase erstellt wurde 
call %OSGEO4W_ROOT%\bin\qgis-orgdir.bat

REM Variablen für Pfad-Ersetzung vorbereiten ...
set "PN=%OSGEO4W_ROOT:"=%"
set "PN=%PN:\=/%"

set "PO=%QGIS_PDIR_ORG:"=%"
set "PO=%PO:\=/%"

set "QO=%QGIS_UDIR_ORG:"=%"
set "QO=%QO:\=/%"

set "QN=%USERPROFILE:\=/%"

set "UN=%QGIS_UDIR:"=%"
set "UN=%UN:\=/%"

set "UO=%PO%/qgis_template"

REM Vorlage für Benutzer-Verzeichnis nach %appdata% kopieren 
xcopy "%PN%/qgis_template" "%UN%" /e /i

REM Original-Pfade der ini-Datei mit den Zielpfaden auf dem Anwender-PC ersetzen 

copy "%UN%\profiles\default\QGIS\QGIS3.ini" "%UN%\profiles\default\QGIS\QGIS3.org"
minised "s#%UO%#%UN%#g;s#%UO:/=\\\\%#%UN:/=\\\\%#g;s#%PO%#%PN%#g;s#%PO:/=\\\\%#%PN:/=\\\\%#g;s#%QO%#%QN%#g;s#%QO:/=\\\\%#%QN:/=\\\\%#g" "%UN%\profiles\default\QGIS\QGIS3.org" > "%UN%\profiles\default\QGIS\QGIS3.ini"

REM Verknüpfungen in der Programmgruppe für alle Benutzer erstellen (public)
if not exist "%ProgramData%\Microsoft\Windows\Start Menu\Programs\QGIS\%QGIS_TEXT%.lnk" (
   nircmd shortcut """%OSGEO4W_ROOT%""\bin\qgis-ltr-start.bat" "%ProgramData%\Microsoft\Windows\Start Menu\Programs\QGIS" "%QGIS_TEXT%" "" """%OSGEO4W_ROOT%""\icons\QGIS.ico" "0" "min" """%OSGEO4W_ROOT%""\bin" ""
   )

if not exist "%ProgramData%\Microsoft\Windows\Start Menu\Programs\QGIS\OSGeo4W Shell.lnk" (
   nircmd shortcut """%OSGEO4W_ROOT%""\OSGeo4W.bat" "%ProgramData%\Microsoft\Windows\Start Menu\Programs\QGIS" "OSGeo4W Shell" "" """%OSGEO4W_ROOT%""\OSGeo4W.ico" "" "" """\" ""
   )

REM Verknüpfung auf dem Desktop für alle Benutzer erstellen (public)
if not exist "%PUBLIC%\Desktop\%QGIS_TEXT%.lnk" (
   nircmd shortcut """%OSGEO4W_ROOT%""\bin\qgis-ltr-start.bat" "%PUBLIC%\Desktop" "%QGIS_TEXT%" "" """%OSGEO4W_ROOT%""\icons\QGIS.ico" "0" "min" """%OSGEO4W_ROOT%""\bin" ""
   )

REM Erstellen von Datei- und Icon-Verknüpfungen

minised "s#x_BASE_x#%PN:/=\\\\%#g;" "%OSGEO4W_ROOT%\bin\qgis.ltr.reg.tmpl" > "%OSGEO4W_ROOT%\bin\qgis.ltr.reg"
start/wait regedit -s "%OSGEO4W_ROOT%\bin\qgis.ltr.reg"

assoc .qgs=QGIS Project
assoc .qlr=QGIS Layer Definition
assoc .qml=QGIS Layer Settings
assoc .qpt=QGIS Composer Template


REM zusätzliche Symbol-Fonts installieren
REM ==========================
REM Anpassung erforderlich!!!!
REM ==========================
REM copy <Quelldatei(en)> C:\Windows\Fonts\<Name der Schrift-/des Symbolfont(en/s)
REM start /wait regedit -s "%OSGEO4W_ROOT%\bin\qgis_sgk_font.reg"
REM start /wait regedit -s "%OSGEO4W_ROOT%\bin\qgis_fonts.reg"


REM Programm beenden
exit /b
